#!/usr/bin/python

import os

encoding="palmLatin"

def testencoding(textfile):
    return 'GLYPH 251' in file(textfile).read()

def makefont(encoding, filename, prcname, origfile):
    mydir = './tmp/'+origfile
    if not os.path.exists(mydir):
        os.mkdir(mydir)
    textfile = "%s/%s.text" % (mydir, prcname)
    os.system("./topalmtext -e -n -%s %s > %s" % (encoding, filename, textfile))
    if not testencoding(textfile):
        os.unlink(textfile)
        return
    os.system("./make_text_narrow.py %s >/tmp/bla.txt" % (textfile) )
    os.rename("/tmp/bla.txt", textfile)
    os.system("./fontconv %s 2a afnx22b8.bin" % (textfile))
    os.system("./toprc %s/%s.prc %s Font fHKv afnx22b8.bin" % (mydir,prcname, prcname))

myencodings = ['palmLatin', 'ISO8859_2', 'CP1250', 'CP1251', 'KOI8R']

#makefont(encoding = encoding, "bla")
fdir = file('/usr/X11R6/lib/X11/fonts/misc/fonts.dir')
fdirl = fdir.readlines()[1:]
for l in fdirl:
    filename, font = l.strip().split(None, 1)
    fields = font.split('-')
    if len(fields)<>15:
        continue
    name = fields[2]
    if name == 'new century schoolbook':
        name = 'ncs'
    style = fields[3]
    it = fields[4]
    size = fields[7]
    if style in ('medium', 'mild','regular'):
        mst = 'R'
    elif style in ('strong', 'bold', 'demibold'):
        mst = 'B'
    else:
        if not style:
            continue
        raise `style`

    if it in ('i','o'):
        it = 'I'
    elif it == 'r':
        it = ''
    else:
        raise
    encoding = fields[-2]+'-'+fields[-1]
    if encoding != 'iso10646-1':
        continue

    for enc in myencodings:
        prcname = name+mst+it+size+'-'+enc
        prcname = prcname.replace(' ','_')
        print "Making", prcname
        makefont(enc, '/usr/X11R6/lib/X11/fonts/misc/'+filename, prcname, filename)
    #print name, style, encoding
