#!/usr/bin/wish
# $Id: toplucker.tcl,v 1.21 2004/02/11 15:35:36 arpruss Exp $
#
proc mainline {} {
       create_widgets
}

proc go { } {
    global bitmapVersions
    global theOutFileName
    global forcePB
    global theDBName
    global theSize
    global styleId
    global orientId
    global fontPrefixes
    global systemSelection
    global systemList
    global fontConvTypes
    global fontList
    global theFileNames
    global orientList
    global orientSelection
    global argv0
    global aaFonts
    global forceNBS
    global disableKerning
    global forceEven
    global .frmRaEn.frmEncoding.box
    global encodings
    global finalEncodings
    global keepEncodings
    global offsets
    global fromRange
    global toRange


    if {[.frmRaEn.frmEncoding.box curselection] == ""} {
         set encoding "none"
    } {
         set encoding [.frmRaEn.frmEncoding.box get [.frmRaEn.frmEncoding.box curselection]]
    }

    set progDir [file dirname $argv0]
    set workingDirExt "_tempDir"
    set toText "$progDir/topalmtext"
    set toGray "$progDir/togray"
    set fontConv "$progDir/fontconv"
    set toPrc "$progDir/toprc"
    set workingDir "$theOutFileName$workingDirExt"
    set bitDepth 4

    set activeFontList ""

    foreach font $fontList {
        if {$theFileNames($font) != ""} {
            lappend activeFontList $font
        }
        if {$keepEncodings($font)} {
            set finalEncodings($font) "none"
        } {
            if {$encodings($font) != "" } {
                set finalEncodings($font) $encodings($font)
            } {
                set finalEncodings($font) $encoding
            }
        }
    }
    if {$activeFontList == ""} {
        tk_messageBox -title "Error" -message "You need to specify at least one font."
        return
    }
    set activeSystemList ""
    foreach system $systemList {
        if {$systemSelection($system)} {
            lappend activeSystemList $system
        }
    }
    if {$activeSystemList == ""} {
        tk_messageBox -title "Error" -message "You need to specify at least one system."
        return
    }
    set activeOrientList ""
    foreach orient $orientList {
        if {$orientSelection($orient)} {
            lappend activeOrientList $orient
        }
    }
    if {$activeOrientList == ""} {
        tk_messageBox -title "Error" -message "You need to specify at least one orientation."
        return
    }
    if {$theOutFileName == ""} {
        tk_messageBox -title "Error" -message "You need to specify the output filename."
        return
    }
    if {$theDBName == ""} {
        tk_messageBox -title "Error" -message "You need to specify the Palm database name."
        return
    }

    file mkdir $workingDir
    set toDelete [glob -nocomplain -path "$workingDir/" *.bin]
    if {$toDelete != ""} {
        eval file delete $toDelete
    }

    if {$aaFonts} {
        set gray "gray"
    } {
        set gray ""
    }
    if {$forceNBS} {
       set opt1 "-f"
    } {
       set opt1 "-f-"
    }
    if {$disableKerning} {
       set opt2 "-n"
    } {
       set opt2 "-n-"
    }
    if {$forceEven} {
       set opt3 "-e"
    } {
       set opt3 "-e-"
    }

    set ranges  [.frmRaEn.frmRanges.box get 0 end]
    set ranges [join $ranges ":"]
    
    foreach font $activeFontList {
         exec $toText -r$ranges -$finalEncodings($font) $opt1 $opt2 $opt3 $theFileNames($font) $theSize($font) $gray > "$workingDir/$font.fonttext"
         if {! $aaFonts} {
             foreach system $activeSystemList {
                 exec $fontConv "$workingDir/$font.fonttext" $fontConvTypes($system) "$workingDir/$fontPrefixes($system)$styleId($font).bin"
             }
         }
    }
    if {$aaFonts} {
        foreach font $activeFontList {
            set commandLine "-W$workingDir/"
            lappend commandLine "-#$offsets($font)"
            foreach system $activeSystemList {
                lappend commandLine $fontPrefixes($system)$styleId($font)
                lappend commandLine "$workingDir/$font.fonttext"
                foreach orient $activeOrientList {
                    lappend commandLine "G$orientId($orient)$bitmapVersions($system)$bitDepth"
                }
                lappend commandLine "-"
            }
            eval exec $toGray $commandLine
        }
    }

    if { $forcePB } {
        set typeName "skin"
        set creatorName "PBLP"
    } {
        set typeName    "Font"
        set creatorName "Plkr"
    }

    set commandLine [list "$theOutFileName" "$theDBName" $typeName $creatorName]
    set commandLine [concat $commandLine [glob -path "$workingDir/" *.bin]]

    eval exec $toPrc $commandLine
    set toDelete [glob -nocomplain -path "$workingDir/" *.bin *.fonttext]
    if {$toDelete != ""} {
        eval file delete $toDelete
    }
    eval file delete "$workingDir"
    tk_messageBox -title "Done!" -message "Produced $theOutFileName."
}

proc getOutFileName { } {
    global theOutFileName
    global theDBName
    set types {
        {{Palm Resource Database}   {.prc}        }
    }
    set theOutFileName [tk_getSaveFile -defaultextension prc -filetypes $types]
    if {$theDBName == ""} then {
        set theDBName [file rootname [file tail $theOutFileName]]
    }
}

proc insertFileName { font } {
    global theFileNames
    global biggerVersion
    global smallerVersion
    global forcePB
    set theFileNames($font) [tk_getOpenFile]
    if {$forcePB} {} {
        if {$biggerVersion($font) != "" && $theFileNames($biggerVersion($font)) == ""} then {
            set theFileNames($biggerVersion($font)) $theFileNames($font)
        }
        if {$smallerVersion($font) != "" && $theFileNames($smallerVersion($font)) == ""} then {
            set theFileNames($smallerVersion($font)) $theFileNames($font)
        }
    }
}


proc add_font_record { font name size id bigger smaller encoding offset } {
    global theFileNames
    global theSize
    global styleId
    global biggerVersion
    global smallerVersion
    global fontList
    global offsets
    global keepEncodings
    global encodings
    global offsets
    lappend fontList $font
    set styleId($font) $id
    set biggerVersion($font) $bigger
    set smallerVersion($font) $smaller
    set theSize($font) $size
    set encodings($font) $encoding
    set offsets($font) $offset
    frame .frm($font)
    label .frm($font).name -text "$name: " -width 12
    entry .frm($font).fileName -width 45 -textvariable theFileNames($font)
    button .frm($font).browse -text "Browse..." -command "insertFileName $font"
    label .frm($font).sizeLabel -text "Size"
    entry .frm($font).size -width 5 -textvariable theSize($font)
    pack .frm($font)
    checkbutton .frm($font).keepEncoding -text "Keep original encoding" -variable keepEncodings($font)
    set $keepEncodings($font) 0
    grid .frm($font).name .frm($font).fileName .frm($font).browse .frm($font).sizeLabel .frm($font).size .frm($font).keepEncoding
}

proc add_system { form system name fontPrefix bitmapVersion fontConvType } {
    global fontPrefixes
    global systemSelection
    global systemList
    global bitmapVersions
    global fontConvTypes
    lappend systemList $system
    set fontPrefixes($system) $fontPrefix
    set bitmapVersions($system) $bitmapVersion
    set fontConvTypes($system) $fontConvType
    checkbutton $form -text "$name" -variable systemSelection($system)
}

proc add_orient { form orient name id default } {
    global orientSelection
    global orientList
    global orientId
    lappend orientList $orient
    set orientId($orient) $id
    set orientSelection($orient) $default
    checkbutton $form -text "$name" -variable orientSelection($orient)
}

proc doForcePB {} {
    global forcePB
    global systemSelection
    global orientSelection
    if { $forcePB } {
        set systemSelection(loRes) 0
        set systemSelection(sony)  0
        set systemSelection(os5)   1
        set orientSelection(normal) 1
        set orientSelection(left)   0
        set orientSelection(right)  0
    }
}

proc addRange {} {
    global fromRange
    global toRange
    .frmRaEn.frmRanges.box insert end $fromRange-$toRange
}

proc delRange {} {
    set todel [.frmRaEn.frmRanges.box curselection]
    if { $todel!="" } {
        .frmRaEn.frmRanges.box delete [.frmRaEn.frmRanges.box curselection]
    }
}


proc create_widgets {} {
    global theOutFileName
    global aaFonts
    global theDBName
    global forceNBS
    global forcePB
    global forceEven
    global disableKerning
    global systemSelection
    global .frmEncoding.box
    add_font_record stdFont        "Standard"    18 "20" "largeFont" "narrow" "" 1000
    add_font_record boldFont       "Bold"        18 "21" "largeBoldFont" "" "" 2000
    add_font_record largeFont      "Large"       21 "22" "" "" "" 3000
    add_font_record largeBoldFont  "Large bold"  21 "23" "" "" "" 4000
    add_font_record narrow         "Narrow"      17 "24" "" "" "" 5000
    add_font_record fixed          "Fixed width" 18 "26" "" "" "" 6000
    add_font_record IstdFont        "Italic"             18 "60" "IlargeFont" "Inarrow" "" 7000
    add_font_record IboldFont       "Italic bold"        18 "61" "IlargeBoldFont" "" "" 8000
    add_font_record IlargeFont      "Italic large"       21 "62" "" "" "" 9000
    add_font_record IlargeBoldFont  "Italic large bold"  21 "63" "" "" "" A000
    add_font_record Inarrow         "Italic narrow"      17 "64" "" "" "" B000
    add_font_record Ifixed          "Italic fixed width" 18 "66" "" "" "" C000
    add_font_record greekFont      "PB+ Greek"       18 "F0" "" "" "GreekKeys" D000
    add_font_record hebrewFont     "PB+ Hebrew"      20 "F1" "" "" "PBPlus_Hebrew" E000
    add_font_record interlinearFont "PB+ Interlinear" 18 "F2" "" "" "PBPlus_Interlinear" 1800
    add_font_record customFont     "PB+ Custom"      18 "F3" "" "" "" F000
    frame .frmOutput
    label .frmOutput.fileNameLabel -text "Output filename: "
    entry .frmOutput.outFileName -width 45 -textvariable theOutFileName
    label .frmOutput.dbNameLabel -text "Palm name: "
    button .frmOutput.browse -text "Browse..." -command "getOutFileName"
    entry .frmOutput.dbName -width 30 -textvariable theDBName
    pack .frmOutput
    grid .frmOutput.fileNameLabel .frmOutput.outFileName .frmOutput.browse
    grid .frmOutput.dbNameLabel .frmOutput.dbName

    frame .frmSystems
    label .frmSystems.label -text "Systems: "
    add_system .frmSystems.loRes loRes "Standard resolution" "NFNT02" 1 "l"
    add_system .frmSystems.sony sony "Sony high resolution (pre-OS5)" "NFNT04" 1 "l"
    add_system .frmSystems.os5 os5 "OS5 high resolution" "nfnt06" 3 "H"
    set systemSelection(os5) 1
    pack .frmSystems
    grid .frmSystems.label .frmSystems.loRes .frmSystems.sony .frmSystems.os5

    frame .frmOrient
    label .frmOrient.label -text "Orientation (only if anti-aliased): "
    add_orient .frmOrient.normal normal "Normal" "U" 1
    add_orient .frmOrient.right right "Clockwise" "R" 0
    add_orient .frmOrient.left left "Counterclockwise" "L" 0
    pack .frmOrient
    grid .frmOrient.label .frmOrient.normal .frmOrient.right .frmOrient.left

    frame .frmGenerate
    label .frmGenerate.label -text "Font generation: "
    checkbutton .frmGenerate.antiAlias -text "Anti-aliasing" -variable aaFonts
    checkbutton .frmGenerate.disableKerning -text "Disable kerning" -variable disableKerning
    checkbutton .frmGenerate.forceNBS -text "Force some Latin 1 chars" -variable forceNBS
    checkbutton .frmGenerate.forceEven -text "Force even width" -variable forceEven
    checkbutton .frmGenerate.pbOnly -text "PalmBible+ only" -variable forcePB -command "doForcePB"
    pack .frmGenerate
    grid .frmGenerate.label .frmGenerate.antiAlias .frmGenerate.forceNBS .frmGenerate.disableKerning .frmGenerate.forceEven .frmGenerate.pbOnly
    set disableKerning 0
    set forceNBS       0
    set forceEven      0
    set forcePB        0

    frame .frmRaEn
    pack .frmRaEn
   
    frame .frmRaEn.addEntry
    grid .frmRaEn.addEntry -row 0 -column 0
   
    entry .frmRaEn.addEntry.fromRange -width 4 -textvariable fromRange
    label .frmRaEn.addEntry.dash -text "-"
    entry .frmRaEn.addEntry.toRange -width 4 -textvariable toRange
    grid .frmRaEn.addEntry.fromRange -row 1 -column 0
    grid .frmRaEn.addEntry.dash -row 1 -column 1
    grid .frmRaEn.addEntry.toRange -row 1 -column 2
    
    button .frmRaEn.addEntry.addButton -text "Add" -command "addRange"
    grid .frmRaEn.addEntry.addButton -row 3 -column 0
    button .frmRaEn.addEntry.delButton -text "Del" -command "delRange"
    grid .frmRaEn.addEntry.delButton -row 3 -column 2
   
    label .frmRaEn.addEntry.label -text "Glyph unicode ranges: "
    grid .frmRaEn.addEntry.label -row 0 -column 0 -columnspan 3
 
    
    frame .frmRaEn.frmRanges
    listbox .frmRaEn.frmRanges.box -selectmode single -height 5 -yscroll ".frmRaEn.frmRanges.scroll set"
    scrollbar .frmRaEn.frmRanges.scroll -command ".frmRaEn.frmRanges.box yview"
    .frmRaEn.frmRanges.box insert 0 "0000-00ff"
    grid .frmRaEn.frmRanges.box -row 0 -column 0 -sticky news
    grid .frmRaEn.frmRanges.scroll -row 0 -column 1 -sticky news
    .frmRaEn.frmRanges.box selection set 1

    grid .frmRaEn.frmRanges -row 0 -column 1

    frame .frmRaEn.frmEncoding
    label .frmRaEn.frmEncoding.label -text "Normal encoding: "

    listbox .frmRaEn.frmEncoding.box -selectmode single -height 5 -yscroll ".frmRaEn.frmEncoding.scroll set"
    scrollbar .frmRaEn.frmEncoding.scroll -command ".frmRaEn.frmEncoding.box yview"
    .frmRaEn.frmEncoding.box insert 0 \
                  "none" "palmLatin" "CP1250" "CP1251" "CP1252" "CP1253" "CP1254" "CP1255" \
                  "CP1256" "CP1257" "CP1258" "CP874" "ISO8859_1" "ISO8859_10" "ISO8859_11" \
                  "ISO8859_13" "ISO8859_14" "ISO8859_15" "ISO8859_16" "ISO8859_2" "ISO8859_3" \
                  "ISO8859_4" "ISO8859_5" "ISO8859_6" "ISO8859_7" "ISO8859_8" "ISO8859_9" "KOI8R" \
                  "PBPlus_Hebrew" "GreekKeys" "PBPlus_Interlinear"

    pack .frmRaEn.frmEncoding
    grid .frmRaEn.frmEncoding.label -row 0 -column 0
    grid .frmRaEn.frmEncoding.box -row 0 -column 1 -sticky news
    grid .frmRaEn.frmEncoding.scroll -row 0 -column 2 -sticky news
    .frmRaEn.frmEncoding.box selection set 1

    grid .frmRaEn.frmEncoding -row 0 -column 2


    frame .frmCommands
    button .frmCommands.go -text "Go!" -command go
    button .frmCommands.cancel -text "Exit" -command exit
    pack .frmCommands
    grid .frmCommands.go .frmCommands.cancel
}

mainline
